#pragma once

#include <JuceHeader.h>
// These will improve the readability of the connection definition

#define getT(Idx) template get<Idx>()
#define connectT(Idx, target) template connect<Idx>(target)
#define getParameterT(Idx) template getParameter<Idx>()
#define setParameterT(Idx, value) template setParameter<Idx>(value)
using namespace scriptnode;
using namespace snex;
using namespace snex::Types;

namespace dspTest_1_impl
{
// =====================| Node & Parameter type declarations |=====================

namespace dspTest_1_t_parameters
{
}

template <int NV>
using dspTest_1_t_ = container::chain<parameter::plain<project::test_1<NV>, 0>, 
                                      wrap::fix<2, project::test_1<NV>>>;

// ========================| Root node initialiser class |========================

template <int NV> struct instance: public dspTest_1_impl::dspTest_1_t_<NV>
{
	
	struct metadata
	{
		static const int NumTables = 0;
		static const int NumSliderPacks = 0;
		static const int NumAudioFiles = 0;
		static const int NumFilters = 0;
		static const int NumDisplayBuffers = 0;
		
		SNEX_METADATA_ID(dspTest_1);
		SNEX_METADATA_NUM_CHANNELS(2);
		SNEX_METADATA_ENCODED_PARAMETERS(20)
		{
			0x005B, 0x0000, 0x5300, 0x7461, 0x7275, 0x7461, 0x6F69, 0x006E, 
            0x0000, 0x0000, 0x0000, 0x3F80, 0x0000, 0x3F80, 0x0000, 0x3F80, 
            0x0000, 0x0000, 0x0000, 0x0000
		};
	};
	
	instance()
	{
		// Node References -------------------------------------------------------
		
		auto& test_1 = this->getT(0); // project::test_1<NV>
		
		// Parameter Connections -------------------------------------------------
		
		this->getParameterT(0).connectT(0, test_1); // Saturation -> test_1::Value
		
		// Default Values --------------------------------------------------------
		
		; // test_1::Value is automated
		
		this->setParameterT(0, 1.);
	}
	
	static constexpr bool isPolyphonic() { return NV > 1; };
};
}

#undef getT
#undef connectT
#undef setParameterT
#undef getParameterT
// =============================| Public Definition |=============================

namespace project
{
// polyphonic template declaration

template <int NV>
using dspTest_1 = wrap::node<dspTest_1_impl::instance<NV>>;
}


