#pragma once

#include <JuceHeader.h>
// These will improve the readability of the connection definition

#define getT(Idx) template get<Idx>()
#define connectT(Idx, target) template connect<Idx>(target)
#define getParameterT(Idx) template getParameter<Idx>()
#define setParameterT(Idx, value) template setParameter<Idx>(value)
using namespace scriptnode;
using namespace snex;
using namespace snex::Types;

namespace test_1_impl
{
// ========================| Node & Parameter type declarations |========================

namespace custom
{

struct test_1_
{
	static float op(float input, float value)
	{
		return input*(1.0f +value*(Math.sin(input*Math.PI)));
	}
};
}

namespace test_1_t_parameters
{
}

template <int NV>
using test_1_t_ = container::chain<parameter::plain<math::expr<NV, custom::test_1_>, 0>, 
                                   wrap::fix<2, math::expr<NV, custom::test_1_>>>;

// ============================| Root node initialiser class |============================

template <int NV> struct instance: public test_1_impl::test_1_t_<NV>
{
	
	struct metadata
	{
		static const int NumTables = 0;
		static const int NumSliderPacks = 0;
		static const int NumAudioFiles = 0;
		static const int NumFilters = 0;
		static const int NumDisplayBuffers = 0;
		
		SNEX_METADATA_ID(test_1);
		SNEX_METADATA_NUM_CHANNELS(2);
		SNEX_METADATA_ENCODED_PARAMETERS(16)
		{
			0x005B, 0x0000, 0x5600, 0x6C61, 0x6575, 0x0000, 0x0000, 0x0000, 
            0x8000, 0x003F, 0x8000, 0x003F, 0x8000, 0x003F, 0x0000, 0x0000
		};
	};
	
	instance()
	{
		// Node References --------------------------------------------------------------
		
		auto& test_1_ = this->getT(0); // math::expr<NV, custom::test_1_>
		
		// Parameter Connections --------------------------------------------------------
		
		this->getParameterT(0).connectT(0, test_1_); // Value -> test_1_::Value
		
		// Default Values ---------------------------------------------------------------
		
		; // test_1_::Value is automated
		
		this->setParameterT(0, 1.);
	}
	
	static constexpr bool isPolyphonic() { return NV > 1; };
};
}

#undef getT
#undef connectT
#undef setParameterT
#undef getParameterT
// =================================| Public Definition |=================================

namespace project
{
// polyphonic template declaration

template <int NV>
using test_1 = wrap::node<test_1_impl::instance<NV>>;
}


